#include <stdio.h> 
#include <stdarg.h>
#include <cra_c.h>

extern const double point2mm;

enum psto_direction { psto_left, psto_right, psto_center
		      , psto_right_leave, psto_center_leave };

extern const char *const ps_newline;

struct cra_psfont {
  const char *name;
  double size;
  double vscale; /* Modifikation des Hoehe-Breite-verhaeltnis */
};

struct cra_psfonts {
  int n;
  struct cra_psfont *fonts;
};

#define N_DEFAULT_CRA_PSFONTS 2
extern struct cra_psfont default_cra_psfonts[N_DEFAULT_CRA_PSFONTS];

#define POINT2MM 2.83465

struct tp_val {
  bool useit;
  union value {
    double d;
    int i;
  } val;
};


struct psoptions { /* Soll fuer eine Postscriptdatei immer gleich bleiben */
  FILE *f;
  struct tp_val lastfont; /* Should not be overwritten */
  struct cra_psfonts fonts; 
};

struct pstextopt { /* kann bei jedem Call anders sein */
  struct psoptions *pso;
  enum psto_direction direction;
  struct tp_val x; /* If !use_this, then print whereever the cursor is */
  struct tp_val y; /* If !use_this, then print whereever the cursor is 
		       This value will be changed by the function to
		       the position of the next line, if zeilenabstand.use_this
		     */


  struct tp_val zeilenabstand; /* if !use_this, don't set nexty and don't
				   do linebreak */
  struct tp_val spaltenbreite; /* if !use_this, don't do linebreak */
  struct tp_val font; /* if !use_this, leave font */
};


struct psoptions *C_psoptions(struct psoptions *pso); /* Default Constructor */
/* Default Constructor */
struct pstextopt *C_pstextopt(struct pstextopt *psto,struct psoptions *pso);
/* Main Function, returns number of char printed */
int pstext( /*not const */ struct pstextopt *ptso,const char* fmt, ...)
#ifdef __GNUC__
     __attribute__ ((format (printf,2,3)))
#endif
;
int vpstext( /*not const*/ struct pstextopt *ptso,const char* fmt, va_list ap);
void ps_fontscale(struct psoptions *pso,double factor);
void ps_beginheader(const struct psoptions *const pso
		    ,const char *const progname);
void ps_endheader(const struct psoptions *const pso);
void ps_newpage(const struct psoptions *const pso, int *const seitenzaehler);
void ps_endfile(const struct psoptions *const pso);
