#include <stdio.h>

#include "testlib1.h"
#include "cra_ex.h"

const char *const lib1_extexte[LIB1_N_EXCEPTIONS] = {
  "Ich mag nun mal keine 3",
  "Ich mag nun mal keine 5"
};

static struct craex_ex tmpex[LIB1_N_EXCEPTIONS] = {
  {0,0},
  {0,0}
};

static const char *const tmptexte[LIB1_N_EXCEPTIONS] = {
  "Ich mag nun mal keine 3",
  "Ich mag nun mal keine 5"
};

struct craex_lib lib1_ex = {
  tmpex, LIB1_N_EXCEPTIONS, tmptexte, "Test-Library 1"
};


int doesnt_like_3(int i)
{
  if (i == 3) {
    craex_hit(lib1_ex, lib1_is3,"Bin in doesnt_like_3 mit 3",NULL);
  }
  return i;
}

int doesnt_like_3or5(int i)
{
  switch (i) {
  case 3: 
    craex_hit(lib1_ex, lib1_is3,"Bin in doesnt_like_3or5 mit 3",NULL);
    break;
  case 5: 
    craex_hit(lib1_ex, lib1_is5,"Bin in doesnt_like_3or5 mit 5",NULL);
    return -1;
    break;
  default:
    return i;
  }
}

int lib1_driver(int val1, int val2)
{
  int retval;
  /* Will exception auf val 3 selbst fangen und die auf 5
     durchlassen
     */
  CRAEX_SET(lib1,is3) {
    retval = doesnt_like_3(val1) + doesnt_like_3or5(val2);
  }
  CRAEX_HANDLE {
    printf("lib1_driver caught is3\n");
    retval =  -1;
  }
  CRAEX_END;
  return retval;
}
